using System;
using System.Collections.Generic;
using System.Text;

namespace Wiz.FileSyncer
{
	class Syncer
	{
		#region [̺Ʈ ]
		public delegate void StateMsgEvent(string msg);
		public delegate void StateEvent();

		public event StateMsgEvent OnSearchStart;
		public event StateEvent OnSearchUpdate;
		public event StateMsgEvent OnSearchFinish;

		public event StateMsgEvent OnSyncStart;
		public event StateMsgEvent OnSyncUpdate;
		public event StateMsgEvent OnSyncFinish;
		public event StateMsgEvent OnSyncerError;

		protected void SearchStart() { if (OnSearchStart != null) { this.OnSearchStart("˻ "); System.Windows.Forms.Application.DoEvents(); } }
		protected void SearchUpdate() { if (OnSearchUpdate != null) { this.OnSearchUpdate(); System.Windows.Forms.Application.DoEvents(); } }
		protected void SearchFinish() { if (OnSearchFinish != null) { this.OnSearchFinish("˻ "); System.Windows.Forms.Application.DoEvents(); } }

		protected void SyncStart() { if (OnSyncStart != null) { this.OnSyncStart("ũ "); System.Windows.Forms.Application.DoEvents(); } }
		protected void SyncUpdate(string msg) { if (OnSyncUpdate != null) { this.OnSyncUpdate(msg); System.Windows.Forms.Application.DoEvents(); } }
		protected void SyncFinish() { if (OnSyncFinish != null) { this.OnSyncFinish("ũ "); System.Windows.Forms.Application.DoEvents(); } }
		protected void SyncerError(string msg) { if (OnSyncerError != null) { this.OnSyncerError(msg); System.Windows.Forms.Application.DoEvents(); } }
		#endregion

		#region []
		/// <summary> ޼</summary>
		private string[] _ErrorMsg = {
				" ϷϿϴ."
			, " ۾ Ͽϴ."
			, " ۾ Ͽϴ."
			};

		private Wiz.FileSyncer.Entity.SyncItemCollection checkList;
		#endregion

		#region [Ӽ]
		#region [Ӽ][IsWorking]
		private bool _IsWorking = false;
		/// <summary>ũ </summary>
		public bool IsWorking
		{
			get { return this._IsWorking; }
			//set { this._IsWorking = value; }
		}
		#endregion

		#region [Ӽ][ īƮ]
		/// <summary>˻׸񰳼(ü)</summary>
		public int CntSET = 0;
		/// <summary>˻׸񰳼(߰)</summary>
		public int CntSEN = 0;
		/// <summary>˻׸񰳼()</summary>
		public int CntSEU = 0;
		/// <summary>˻׸񰳼()</summary>
		public int CntSED = 0;

		/// <summary>ũ׸񰳼(ü)</summary>
		public int CntSYT = 0;
		/// <summary>ũ׸񰳼()</summary>
		public int CntSYR = 0;
		/// <summary>ũ׸񰳼()</summary>
		public int CntSYE = 0;
		#endregion
		#endregion

		#region [޼ҵ]
		#region [޼ҵ][ReSet]
		/// <summary>ʱȭ Ѵ.</summary>
		public void ReSet()
		{
			this.resetSearchCount();
			this.resetSyncCount();
			this._IsWorking = false;
		}
		#endregion

		#region [RunSync]
		/// <summary> ũ Ѵ.</summary>
		/// <param name="lItems">ũ Ʈ</param>
		/// <returns></returns>
		public bool RunSync(Wiz.FileSyncer.Entity.ListItemCollection li, bool isRoop)
		{
			this._IsWorking = true;
			GetSyncList(li);	// ũ Ʈ 
			syncProcess();	// /Ʈ/߰ 
			if (!isRoop) { this._IsWorking = false; }
			return true;
		}
		#endregion

		#region [޼ҵ][StopProcess]
		/// <summary> ۾ .</summary>
		public void StopProcess() { this._IsWorking = false; }
		#endregion

		#region [GetSyncList]
		/// <summary> ũƮ .</summary>
		/// <param name="lItems">ũ Ʈ</param>
		/// <returns></returns>
		public bool GetSyncList(Wiz.FileSyncer.Entity.ListItemCollection lis)
		{
			resetSearchCount();	// ˻ īƮ ʱȭ
			resetSyncCount();	// ũ īƮ ʱȭ
			this.checkList = new Wiz.FileSyncer.Entity.SyncItemCollection();

			this.SearchStart();

			foreach (Wiz.FileSyncer.Entity.ListItem li in lis)
			{
				if (!this._IsWorking) { return false; }
				if (li.IsSyncItem == System.Windows.Forms.CheckState.Checked)
				{
					switch (li.SyncType)
					{
						////case 3:
						////    this.sDir3(li.SourcePath, li.TargetPath, li.CreateAllow, li.ChangeAllow);
						////    break;
						case 2:
							DateTime syncEDate = DateTime.Now;
							if (!li.SyncEDateToday) { syncEDate = li.SyncEDate; }
							this.sDir2(li.SourcePath, li.TargetPath, li.SyncSDate, syncEDate);
							break;
						default:
						case 1:
							if (li.CreateAllow | li.ChangeAllow) { this.sDir1_CU(li.SourcePath, li.TargetPath, li.CreateAllow, li.ChangeAllow); }
							if (li.DeleteAllow) { this.sDir1_Delete(li.SourcePath, li.TargetPath, li.DeleteAllow); }
							break;
					}
				}
			}

			this.SearchFinish();
			
			return true;
		}
		#endregion
		#endregion

		#region [Լ] ˻ μ
		#region [sDir2] 
		private bool sDir2(string srcPath, string tgPath, DateTime syncSDate, DateTime syncEDate)
		{
			if (!this._IsWorking) { return false; }

			bool isFileUpdated = false;
			System.IO.DirectoryInfo dis = new System.IO.DirectoryInfo(srcPath);	//  ͸

			//   ó 
			foreach (System.IO.FileInfo fi in dis.GetFiles())
			{
				if (!this._IsWorking) { return false; }
				CntSET++;
				if (fi.LastWriteTime >= syncSDate && fi.LastWriteTime <= syncEDate)
				{ this.checkList.Add(new Wiz.FileSyncer.Entity.SyncItem(ItemSyncTypes.FileCopy, tgPath + fi.Name, srcPath + fi.Name)); CntSEN++; isFileUpdated = true; }	// Ʈ  ߰
			}

			foreach (System.IO.DirectoryInfo di in dis.GetDirectories())
			{
				CntSET++;
				string srcSubDirPath = (srcPath + di.Name + "\\");	// ҽ  ͸ 
				string tgSubDirPath = (tgPath + di.Name + "\\");	// Ÿ  ͸ 
				if (System.IO.Directory.Exists(srcSubDirPath))
				{ sDir2(srcSubDirPath, tgSubDirPath, syncSDate, syncEDate); }	// ˻   ͸ ִ  ͸ Ž
				this.SearchUpdate();
			}

			if(isFileUpdated && !System.IO.Directory.Exists(tgPath))
			{ this.checkList.Insert(0, new Wiz.FileSyncer.Entity.SyncItem(ItemSyncTypes.DirCopy, tgPath)); CntSEN++; }	//  ͸   Ʈ ͸ ߰

			this.SearchUpdate();
			return true;
		}
		#endregion

		#region [sDir1_CU] 
		private bool sDir1_CU(string srcPath, string tgPath, bool createAllow, bool changeAllow)
		{
			if (!this._IsWorking) { return false; }

			System.IO.DirectoryInfo dis = new System.IO.DirectoryInfo(srcPath);	//  ͸
			if (!System.IO.Directory.Exists(tgPath))
			{ this.checkList.Add(new Wiz.FileSyncer.Entity.SyncItem(ItemSyncTypes.DirCopy, tgPath)); CntSEN++; }	//  ͸   Ʈ ͸ ߰

			foreach (System.IO.DirectoryInfo di in dis.GetDirectories())
			{
				if (!this._IsWorking) { return false; }
				CntSET++;
				string srcSubDirPath = (srcPath + di.Name + "\\");	// ҽ  ͸ 
				string tgSubDirPath = (tgPath + di.Name + "\\");	// Ÿ  ͸ 
				if (System.IO.Directory.Exists(srcSubDirPath))
				{
					if (!this._IsWorking) { return false; }
					sDir1_CU(srcSubDirPath, tgSubDirPath, createAllow, changeAllow);	// ͸ Ž
				}	// ˻   ͸ ִ 
				this.SearchUpdate();
			}

			//   ó 
			foreach (System.IO.FileInfo fi in dis.GetFiles())
			{
				if (!this._IsWorking) { return false; }
				if (System.IO.File.Exists(tgPath + fi.Name))
				{
					CntSET++;
					if (createAllow)
					{
						System.IO.FileInfo dfi = new System.IO.FileInfo(tgPath + fi.Name);
						if (fi.LastWriteTime > dfi.LastWriteTime)
						{ this.checkList.Add(new Wiz.FileSyncer.Entity.SyncItem(ItemSyncTypes.FileCopy, tgPath + fi.Name, srcPath + fi.Name)); CntSEU++; }
					}
				}	// Ʈ
				else
				{
					if (createAllow)
					{ this.checkList.Add(new Wiz.FileSyncer.Entity.SyncItem(ItemSyncTypes.FileCopy, tgPath + fi.Name, srcPath + fi.Name)); CntSEN++; }
				}	// 
			}
			this.SearchUpdate();
			return true;
		}
		#endregion

		#region [sDir1_Delete] 
		private bool sDir1_Delete(string srcPath, string tgPath, bool deleteAllow)
		{
			if (!this._IsWorking) { return false; }
			if (!System.IO.Directory.Exists(tgPath)) { return true; }

			System.IO.DirectoryInfo dis = new System.IO.DirectoryInfo(tgPath);	//  ͸
			if (!System.IO.Directory.Exists(srcPath))
			{ this.checkList.Add(new Wiz.FileSyncer.Entity.SyncItem(ItemSyncTypes.DirDelete, tgPath)); CntSED++; return true; }	//  ͸   Ʈ ͸ ߰

			foreach (System.IO.DirectoryInfo di in dis.GetDirectories())
			{
				if (!this._IsWorking) { return false; }
				CntSET++;
				string srcSubDirPath = (srcPath + di.Name + "\\");	// ҽ  ͸ 
				string tgSubDirPath = (tgPath + di.Name + "\\");	// Ÿ  ͸ 
				if (System.IO.Directory.Exists(tgSubDirPath))
				{ sDir1_Delete(srcSubDirPath, tgSubDirPath, deleteAllow); } // ͸ Ž }	// ˻   ͸ ִ 
				this.SearchUpdate();
			}

			//   ó 
			foreach (System.IO.FileInfo fi in dis.GetFiles())
			{
				if (!this._IsWorking) { return false; }
				CntSET++;
				if (!System.IO.File.Exists(srcPath + fi.Name))
				{
					if (deleteAllow) { this.checkList.Add(new Wiz.FileSyncer.Entity.SyncItem(ItemSyncTypes.FileDelete, tgPath + fi.Name)); CntSED++; }
				}	//  
			}
			this.SearchUpdate();
			return true;
		}
		#endregion

		#region [sDir3] 
		//////private bool sDir3(string srcPath, string tgPath, bool createAllow, bool changeAllow)
		//////{
		//////    if (this._IsWorking)
		//////    {
		//////        System.IO.DirectoryInfo dis = new System.IO.DirectoryInfo(srcPath);	//  ͸
		//////        if (!System.IO.Directory.Exists(tgPath))
		//////        { this.checkList.Add(new Wiz.FileSyncer.Entity.SyncItem(ItemSyncTypes.DirCopy, tgPath)); }	//  ͸   Ʈ ͸ ߰

		//////        foreach (System.IO.DirectoryInfo di in dis.GetDirectories())
		//////        {
		//////            string srcSubDirPath = (srcPath + di.Name);	// ҽ  ͸ 
		//////            string tgSubDirPath = (tgPath + di.Name);	// Ÿ  ͸ 
		//////            if (System.IO.Directory.Exists(srcSubDirPath))
		//////            {
		//////                sDir1(srcSubDirPath, tgSubDirPath, createAllow, changeAllow);	// ͸ Ž
		//////            }	// ˻   ͸ ִ 
		//////        }

		//////        //   ó 
		//////        foreach (System.IO.FileInfo fi in dis.GetFiles())
		//////        {
		//////            if (System.IO.File.Exists(tgPath + fi.Name))
		//////            {
		//////                if (createAllow)
		//////                {
		//////                    System.IO.FileInfo dfi = new System.IO.FileInfo(tgPath + fi.Name);
		//////                    if (fi.LastWriteTime > dfi.LastWriteTime)
		//////                    { this.checkList.Add(new Wiz.FileSyncer.Entity.SyncItem(ItemSyncTypes.FileCopy, tgPath + fi.Name, srcPath + fi.Name)); }
		//////                    else if (fi.LastWriteTime < dfi.LastWriteTime)
		//////                    { this.checkList.Add(new Wiz.FileSyncer.Entity.SyncItem(ItemSyncTypes.FileCopy, tgPath + fi.Name, srcPath + fi.Name)); }
		//////                }
		//////            }	// Ʈ
		//////            else
		//////            {
		//////                if (createAllow)
		//////                { this.checkList.Add(new Wiz.FileSyncer.Entity.SyncItem(ItemSyncTypes.FileCopy, tgPath + fi.Name, srcPath + fi.Name)); }
		//////            }	// 
		//////        }
		//////    }
		//////    return true;
		//////}
		#endregion
		#endregion

		#region [Լ]
		#region [syncProcess]
		/// <summary>ũ  Ѵ.</summary>
		private void syncProcess()
		{
			if (this._IsWorking)
			{
				resetSyncCount();	// ũ īƮ ʱȭ
				this.CntSYT = this.checkList.Count;
				this.SyncStart();

				// Ʈ  ó Ѵ.
				string msg = "";
				foreach (Wiz.FileSyncer.Entity.SyncItem li in this.checkList)
				{
					if (!this._IsWorking) { break; }
					switch (li.SyncType)
					{
						case ItemSyncTypes.DirCopy:
							try
							{
								System.IO.Directory.CreateDirectory(li.TrgPath);
								msg = ("DIR  : " + li.TrgPath);
								CntSYR++;
							}
							catch (Exception em) { this.SyncerError(em.Message); CntSYE++; }
							break;
						case ItemSyncTypes.DirDelete:
							try
							{
								System.IO.Directory.Delete(li.TrgPath, true);
								msg = ("DIR  : " + li.TrgPath);
								CntSYR++;
							}
							catch (Exception em) { this.SyncerError(em.Message); CntSYE++; }
							break;
						case ItemSyncTypes.FileCopy:
							try
							{
								System.IO.File.Copy(li.SrcPath, li.TrgPath, true);
								msg = ("  : " + li.SrcPath + "\t" + li.TrgPath);
								CntSYR++;
							}
							catch (Exception em) { this.SyncerError(em.Message); CntSYE++; }
							break;
						case ItemSyncTypes.FileDelete:
							try
							{
								System.IO.File.Delete(li.TrgPath);
								msg = ("  : " + li.TrgPath);
								CntSYR++;
							}
							catch (Exception em) { this.SyncerError(em.Message); CntSYE++; }
							break;
					}
					this.SyncUpdate(msg);
				}
				this.SyncFinish();
			}
		}
		#endregion
		#endregion

		#region [Լ]
		#region [Լ][resetSearchCount]
		private void resetSearchCount()
		{
			CntSET = 0;
			CntSEN = 0;
			CntSEU = 0;
			CntSED = 0;
		}
		#endregion

		#region [Լ][resetSyncCount]
		private void resetSyncCount()
		{
			CntSYT = 0;
			CntSYR = 0;
			CntSYE = 0;
		}
		#endregion
		#endregion
	}
}